import java.io.*;
import java.lang.*;
import java.util.Vector;
import java.io.File;


public class statPB {
Vector vplr;
Vector vblr;

public statPB(){
vplr= new Vector();
vblr= new Vector();
}

public static int IndiceBianco(String s){   /*calcolo la posizione del primo spazio all'interno di una stringa*/
char c;
int h=0;
for (h=0; h<s.length(); h++){
	c=s.charAt(h);
	if(Character.isWhitespace(c))
		break;
}
return h;
}



public double calcoloPB (double d, int flow, String pathFileTrace){

String str, seq;
double tempo=0.0;
int n0=0;
int n1=0;
int n2=0;
int n3=0;
int size=0;
int intplr=0;
int intblr=0;
int flw=0;

double tempoMax=0.0; //tempo massimo del filetrace

double finestra=d;
double finestraOld=0.0;
Double wnd;
Integer plr;
Integer blr;

boolean perso=false;

File fileTrace = new File(pathFileTrace);

try{

FileReader file=new FileReader(fileTrace);
BufferedReader buff=new BufferedReader(file);  /*lettura da file*/

while ((str=buff.readLine())!=null){                /*per ogni riga del file trace*/
n1=IndiceBianco(str);                                 /*catturo informazione relativa al tipo di evento*/
seq=str.substring(n0,n1);
str=str.substring(n1+1, str.length());

if (seq.compareTo("d")==0){                         /*verifico se l'evento coincide con la perdita del pacchetto*/
	perso=true;

	}


n2=IndiceBianco(str);
seq=str.substring(n0,n2);
str=str.substring(n2+1, str.length());
tempo=Double.valueOf(seq).doubleValue();         /*catturo informazione relativa all'istante in cui e' avvenuto l' evento*/



if(tempo<=finestra){
	if(perso){

	for(int k=0;k<6; k++){
	n3=IndiceBianco(str);
	seq=(String)str.subSequence(n0,n3);
   	str=str.substring(n3+1, str.length());
	if(k==3){size=Integer.valueOf(seq).intValue();}    /*catturo informazione relativa alle dimensioni del pacchetto*/
	}
	flw=Integer.valueOf(seq).intValue();               //flw=flusso (int)
	if(flw==flow){                                      /*verifico che il flusso sia quello corretto*/
		intplr++;
		intblr=intblr+size;
	}

	}

}
else{

tempoMax=tempo; //incremento variabile che salva ultimo tempo filetrace

finestraOld=finestra;
finestra=finestra+d;          /*incremento il valore della finestra*/
finestra=finestra*1000;	      /*arrotondo*/
finestra=(Math.rint(finestra)/1000);

plr=new Integer(intplr);
blr=new Integer(intblr);

intplr=0;                    //azzero plr e blr
intblr=0;

wnd=new Double(finestraOld);
vplr.add(wnd);
vblr.add(wnd);
vplr.add(plr);
vblr.add(blr);


	if(perso){   //controllo se nella prima riga della finestra c'�una d

	for(int k=0;k<6; k++){
	n3=IndiceBianco(str);
	seq=(String)str.subSequence(n0,n3);
   	str=str.substring(n3+1, str.length());
	if(k==3){size=Integer.valueOf(seq).intValue();} //prendo size
	}
	flw=Integer.valueOf(seq).intValue();            //flw=flusso(int)
	if(flw==flow){
		intplr++;
		intblr=intblr+size;
	}

	}



}
perso=false;  //ripristino a false il flag per l'evento 'd'

}

plr=new Integer(intplr);
blr=new Integer(intblr);
wnd=new Double(finestra);
vplr.add(wnd);
vblr.add(wnd);
vplr.add(plr);
vblr.add(blr);

buff.close(); //buffer chiuso

}catch (IOException e){ }

return tempoMax;
}


public void creaFile(String fileName, boolean pb){


try{


if(pb){
FileWriter fileOut=new FileWriter(fileName+"_p.dat"); //file _p.dat
BufferedWriter buffOut=new BufferedWriter(fileOut);
PrintWriter printOut=new PrintWriter(buffOut);
printOut.println("#Tempo    PLR");                     //prima riga
printOut.println("0.0       0");
for (int i=0;i<vplr.size(); i++){
	printOut.print(vplr.elementAt(i));//scrive il tempo
	i++;
	printOut.print("       ");
	printOut.println(vplr.elementAt(i));//scrive il plr
	}
printOut.close();
}
else{
FileWriter fileOut=new FileWriter(fileName+"_b.dat"); //file _b.dat
BufferedWriter buffOut=new BufferedWriter(fileOut);
PrintWriter printOut=new PrintWriter(buffOut);
printOut.println("#Tempo    BLR");//prima riga
printOut.println("0.0       0");
for (int j=0;j<vblr.size(); j++){
	printOut.print(vblr.elementAt(j));//scrive il tempo
	j++;
	printOut.print("       ");
	printOut.println(vblr.elementAt(j));//scrive blr
	}
printOut.close();
}

}
catch(IOException e){}
}



}
