import java.io.*;
import java.lang.*;
import java.util.Vector;

public class statRitE {
Vector vrit; //id,tempoIn di inviati
Vector vritardi; //lista ritardi di ricevuti
Double ritardoMax, ritardoMin; //per calcolare finestra ritardo e-t-e

public statRitE(){
vrit= new Vector();
vritardi=new Vector();
ritardoMax=new Double(0.0);
ritardoMin=new Double(0.0);
}

public static int IndiceBianco(String s){
char c;
int h=0;
for (h=0; h<s.length(); h++){
	c=s.charAt(h);
	if(Character.isWhitespace(c))
		break;
}
return h;
}

public double calcoloRit (double quant,int flow, String fileDel, String pathFileTrace){ //calcolo ritardi e-t-e e li metto in vector ritardi

double tempoIn=0.0;
double tempoOut=0.0;
int nodoIn=0;
int nodoOut=0;
int nodoPIn=0;
int nodoPOut=0;
int flusso=0;
int id=0;

String str, seq;
int n0=0;
int n1=0;
int n2=0;
int n3=0;

Double ritardoTemp;

try{

FileReader file=new FileReader(pathFileTrace);
BufferedReader buff=new BufferedReader(file);


while ((str=buff.readLine())!=null){  //scorro ogni riga del trace file
n1=IndiceBianco(str);
seq=str.substring(n0,n1); //contiene il tipo di evento per quella riga
str=str.substring(n1+1, str.length());

if (seq.compareTo("+")==0){ // se l'evento un enqueue

	for(int k=0;k<11; k++){     //catturo le inforamazioni contenute nella riga
		if(k==10){
			id=Integer.valueOf(str).intValue(); //PACKET ID
			break;
			}
		n3=IndiceBianco(str);
		seq=(String)str.subSequence(n0,n3);
   		str=str.substring(n3+1, str.length());
		if(k==0){tempoIn=Double.valueOf(seq).doubleValue();}  //istante di invio del pacchetto
		if(k==1){nodoIn=Integer.valueOf(seq).intValue();}     //nodo dal quale �stato inviato
		if(k==7){nodoPIn=(int)Float.valueOf(seq).floatValue();} //nodo di partenza
		if(k==6){flusso=Integer.valueOf(seq).intValue();} //flusso ATTENZIONE!!!
	}

	if(flusso==flow && nodoIn==nodoPIn){ //inserisco dati nel vector vrit se il flusso ok e se il pacchetto �stato inviato dal nodo di partenza
		ObjRit inviato = new ObjRit(id,tempoIn);
		vrit.add(inviato);
	}

}

if (seq.compareTo("r")==0){

	for(int k=0;k<11; k++){
		if(k==10){
			id=Integer.valueOf(str).intValue();
			break;
			}
		n3=IndiceBianco(str);
		seq=(String)str.subSequence(n0,n3);
   		str=str.substring(n3+1, str.length());
		if(k==0){tempoOut=Double.valueOf(seq).doubleValue();}
		if(k==2){nodoOut=Integer.valueOf(seq).intValue();}
		if(k==8){nodoPOut=(int)Float.valueOf(seq).floatValue();}
		if(k==6){flusso=Integer.valueOf(seq).intValue();}
	}
	if(flusso==flow && nodoOut==nodoPOut){ //prendo dati dal vector

		for(int i=0;i<vrit.size(); i++){
			ObjRit contr;
			contr = (ObjRit)vrit.elementAt(i);

			if(contr.vId==id){   //calcolo tempo min e tempo max per finestra ritardo e-t-e
				ritardoTemp=new Double(tempoOut-contr.vTempoIn); //valuto il ritardo tra l'invio e l'arrivo
				vritardi.add(ritardoTemp);
				if((ritardoTemp.compareTo(ritardoMax))>0){
					ritardoMax=ritardoTemp;
				}
				if((ritardoTemp.compareTo(ritardoMin))<0){
					ritardoMin=ritardoTemp;
				}
				if(i==1){
					ritardoMin=ritardoTemp;
				}

			}

		}

	}


}


}

buff.close();
}catch (IOException e){ }
double tM=calcoloGrafico (quant,fileDel);
return tM;
}

public double calcoloGrafico (double quant, String fileName){


double calcoloPos; //per posizione nel grafico ritardo

int nQuant=(int)((ritardoMax.doubleValue()-ritardoMin.doubleValue())/quant); //numero quantili
int[] grafQuant=new int[nQuant+1];

for (int j=0; j<vritardi.size(); j++){        //incremento il contatore dei pacchetti con un dato ritardo
	for (int i=0; i<grafQuant.length; i++){
		Double r = (Double)vritardi.elementAt(j);
		if (r.doubleValue()<(ritardoMin.doubleValue()+(quant*(i+1)))){
			grafQuant[i]=grafQuant[i]+1;
			break;
		}

	}
}


try{
FileWriter fileOut=new FileWriter(fileName+"_d.dat");
BufferedWriter buffOut=new BufferedWriter(fileOut);
PrintWriter printOut=new PrintWriter(buffOut);

printOut.println("#Quantile = istante di inizio del quantile");//prima riga
printOut.println("#Quantile      Numero pacchetti ");

for(int i=0; i<grafQuant.length; i++){
	printOut.print(i*quant);
	printOut.print("            ");
	printOut.println(grafQuant[i]);//numero pacchetti relativi al quantile

}
// aggiungiamo un ulteriore riga per migliorare la visibilita del grafico
printOut.print((grafQuant.length)*quant);
printOut.print("            ");
printOut.println("0");

printOut.close();
}
catch(IOException e){}
return (grafQuant.length)*quant;
}


}
